{
"resultCode": "A001215",
"resultMessage": "[A001215] /auth/authorization, The client (ID = 26837717140341) is locked."
}
{
"resultCode": "A001311",
"resultMessage": "[A001311] /auth/authorization, Too many requests, retry after 1 seconds. (Entity: 23769878923/87122303)"
}
{
"resultCode": "A001101",
"resultMessage": "[A001101] /auth/authorization, Authlete Server error."
}
CIBA
Process Backchannel Authentication Request
This API parses request parameters of a backchannel authentication request and returns necessary data for the authorization server implementation to process the backchannel authentication request further.
POST
/
api
/
{serviceId}
/
backchannel
/
authentication
Typescript (SDK)
import { Authlete } from "@authlete/typescript-sdk";const authlete = new Authlete({ serviceId: "<id>", bearer: process.env["AUTHLETE_BEARER"] ?? "",});async function run() { const result = await authlete.ciba.processAuthentication({ backchannelAuthenticationRequest: { parameters: "login_hint=john&scope=openid&client_notification_token=my-client-notification-token&user_code=my-user-code", clientId: "26862190133482", clientSecret: "8J9pAEX6IQw7lYtYGsc_s9N4jlEz_DfkoCHIswJjFjfgKZX-nC4EvKtaHXcP9mHBfS7IU4jytjSZZpaK9UJ77A", }, }); console.log(result);}run();
require 'authlete_ruby_sdk'
Models = ::Authlete::Models
s = ::Authlete::Client.new(
service_id: '<id>',
bearer: '<YOUR_BEARER_TOKEN_HERE>'
)
res = s.ciba.process_authentication(backchannel_authentication_request: Models::Components::BackchannelAuthenticationRequest.new(
parameters: 'login_hint=john&scope=openid&client_notification_token=my-client-notification-token&user_code=my-user-code',
client_id: '26862190133482',
client_secret: '8J9pAEX6IQw7lYtYGsc_s9N4jlEz_DfkoCHIswJjFjfgKZX-nC4EvKtaHXcP9mHBfS7IU4jytjSZZpaK9UJ77A'
))
unless res.backchannel_authentication_response.nil?
# handle response
end
{
"resultCode": "A001215",
"resultMessage": "[A001215] /auth/authorization, The client (ID = 26837717140341) is locked."
}
{
"resultCode": "A001311",
"resultMessage": "[A001311] /auth/authorization, Too many requests, retry after 1 seconds. (Entity: 23769878923/87122303)"
}
{
"resultCode": "A001101",
"resultMessage": "[A001101] /auth/authorization, Authlete Server error."
}
Full description
This API is supposed to be called from within the implementation of the backchannel authentication endpoint of the service. The endpoint implementation must extract the request parameters from the backchannel authentication request from the client application and pass them as the value of parameters request parameter for Authlete’s /backchannel/authentication API. The value of parameters is the entire entity body (which is formatted in application/x-www-form-urlencoded) of the request from the client application. The following code snippet is an example in JAX-RS showing how to extract request parameters from the backchannel authentication request.
@POST@Consumes(MediaType.APPLICATION_FORM_URLENCODED)public Response post(String parameters){// 'parameters' is the entity body of the backchannel authentication request.......}
The endpoint implementation does not have to parse the request parameters from the client application because Authlete’s /backchannel/authentication API does it. The response from /backchannel/authentication API has various parameters. Among them, it is action parameter that the authorization server implementation should check first because it denotes the next action that the authorization server implementation should take. According to the value of action, the service implementation must take the steps described below.
When the value of action is INTERNAL_SERVER_ERROR, it means that the request from the authorization server implementation was wrong or that an error occurred in Authlete. In either case, from the viewpoint of the client application, it is an error on the server side. Therefore, the service implementation should generate a response to the client application with HTTP status of “500 Internal Server Error” and application/json. The value of responseContent is a JSON string which describes the error, so it can be used as the entity body of the response.The following illustrates the response which the service implementation should generate and return to the client application.
HTTP/1.1 500 Internal Server ErrorContent-Type: application/jsonCache-Control: no-storePragma: no-cache{responseContent}
When the value of action is BAD_REQUEST, it means that the request from the client application is invalid. The authorization server implementation should generate a response to the client application with “400 Bad Request” and application/json. The value of responseContent is a JSON string which describes the error, so it can be used as the entity body of the response.The following illustrates the response which the service implementation should generate and return to the client application.
HTTP/1.1 400 Bad RequestContent-Type: application/jsonCache-Control: no-storePragma: no-cache{responseContent}
When the value of action is UNAUTHORIZED, it means that client authentication of the backchannel authentication request failed. Note that client authentication is always required at the backchannel authentication endpoint. This implies that public clients are not allowed to use the backchannel authentication endpoint. The authorization server implementation should generate a response to the client application with “401 Unauthorized” and application/json. The value of responseContent is a JSON string which describes the error, so it can be used as the entity body of the response.The following illustrates the response which the service implementation must generate and return to the client application.
When the value of action is USER_IDENTIFICATION, it means that the backchannel authentication request from the client application is valid. The authorization server implementation has to follow the steps below.[1] END-USER IDENTIFICATIONThe first step is to determine the subject (= unique identifier) of the end-user from whom the client application wants to get authorization. According to the CIBA specification, a backchannel authentication request contains one (and only one) of the login_hint_token, id_token_hint and login_hint request parameters as a hint by which the authorization server identifies the subject of an end-user. The authorization server implementation can know which hint is included in the backchannel authentication request by the hintType parameter. For example, when the value of the parameter LOGIN_HINT, it means that the backchannel authentication request contains the login_hint request parameter as a hint. The value of the hint parameter is the value of the hint. For example, when the value of the hintType parameter is LOGIN_HINT, The value of the hint parameter is the value of the login_hint request parameter. It is up to the authorization server implementation how to determine the subject of the end-user from the hint. Only when the id_token_hint request parameter is used, authorization server implementation can use the sub response parameter, which holds the value of the sub claim in the id_token_hint request parameter.[2] END-USER IDENTIFICATION ERRORThere are some cases where the authorization server implementation encounters an error during the user identification process. In any error case, the service implementation has to return an HTTP response with the error response parameter to the client application. The following is an example of such error responses.
HTTP/1.1 400 Bad RequestContent-Type: application/jsonCache-Control: no-storePragma: no-cache{ "error":"unknown_user_id" }
Authlete provides /backchannel/authentication/fail API that builds the response body (JSON) of an error response. However, because it is easy to build an error response manually, you may choose not to call the API. One good thing in using the API is that the API call can trigger deletion of the ticket which has been issued from Authlete’s /backchannel/authentication API. If you don’t call /backchannel/authentication/fail API, the ticket will continue to exist in the database until it is cleaned up by the batch program after the ticket expires. Possible error cases that the authorization server implementation itself has to handle are as follows. Other error cases have already been covered by /backchannel/authentication API.
expired_login_hint_token The authorization server implementation detected that the hint presented by the login_hint_token request parameter has expired. Note that the format of login_hint_token is not described in the CIBA Core spec at all and so there is no consensus on how to detect expiration of login_hint_token. Interpretation of login_hint_token is left to each authorization server implementation.
unknown_user_id The authorization server implementation could not determine the subject of the end-user by the presented hint.
unauthorized_client The authorization server implementation has custom rules to reject backchannel authentication requests from some particular clients and found that the client which has made the backchannel authentication request is one of the particular clients. Note that /backchannel/authentication API does not return action=USER_IDENTIFICATION in cases where the client does not exist or client authentication has failed. Therefore, the authorization server implementation will never have to use the error code unauthorized_client unless the server has intentionally implemented custom rules to reject backchannel authentication requests based on clients.
missing_user_code The authorization server implementation has custom rules to require that a backchannel authentication request include a user code for some particular users and found that the user identified by the hint is one of the particular users. Note that /backchannel/authentication API does not return action=USER_IDENTIFICATION when both the backchannel_user_code_parameter_supported metadata of the server and the backchannel_user_code_parameter metadata of the client are true and the backchannel authentication request does not include the user_code request parameter. In this case, /backchannel/authentication API returns action=BAD_REQUEST with JSON containing "error":"missing_user_code". Therefore, the authorization server implementation will never have to use the error code missing_user_code unless the server has intentionally implemented custom rules to require a user code based on users even in the case where the backchannel_user_code_parameter metadata of the client which has made the backchannel authentication request is false.
invalid_user_code The authorization server implementation detected that the presented user code is invalid. Note that the format of user_code is not described in the CIBA Core spec at all and so there is no consensus on how to judge whether a user code is valid or not. It is up to each authorization server implementation how to handle user codes.
invalid_binding_message The authorization server implementation detected that the presented binding message is invalid. Note that the format of binding_message is not described in the CIBA Core spec at all and so there is no consensus on how to judge whether a binding message is valid or not. It is up to each authorization server implementation how to handle binding messages.
invalid_target The authorization server implementation rejects the requested target resources. The error code invalid_target is from “Resource Indicators for OAuth 2.0”. The specification defines the resource request parameter. By using the parameter, client applications can request target resources that should be bound to the access token being issued. If the authorization server wants to reject the request, call /backchannel/authentication/fail API with INVALID_TARGET.
access_denined The authorization server implementation has custom rules to reject backchannel authentication requests without asking the end-user and respond to the client as if the end-user had rejected the request in some particular cases and found that the backchannel authentication request is one of the particular cases. The authorization server implementation will never have to use the error code access_denied at this timing unless the server has intentionally implemented custom rules to reject backchannel authentication requests without asking the end-user and respond to the client as if the end-user had rejected the request.
[3] AUTH_REQ_ID ISSUEIf the authorization server implementation has successfully determined the subject of the end-user, the next action is to return an HTTP response to the client application which contains auth_req_id. Authlete provides /backchannel/authentication/issue API which generates a JSON containing auth_req_id, so, your next action is (1) call the API, (2) receive the response from the API, (3) build a response to the client application using the content of the API response, and (4) return the response to the client application. See the description of /backchannel/authentication/issue API for details.[4] END-USER AUTHENTICATION AND AUTHORIZATIONAfter sending a JSON containing auth_req_id back to the client application, the service implementation starts to communicate with an authentication device of the end-user. It is assumed that end-user authentication is performed on the authentication device and the end-user confirms the content of the backchannel authentication request and grants authorization to the client application if everything is okay. The authorization server implementation must be able to receive the result of the end-user authentication and authorization from the authentication device. How to communicate with an authentication device and achieve end-user authentication and authorization is up to each authorization server implementation, but the following request parameters of the backchannel authentication request should be taken into consideration in any implementation.
acr_values A backchannel authentication request may contain an array of ACRs (Authentication Context Class References) in preference order. If multiple authentication devices are registered for the end-user, the authorization server implementation should take the ACRs into consideration when selecting the best authentication device.
scope A backchannel authentication request always contains a list of scopes. At least, openid is included in the list (otherwise /backchannel/authentication API returns action=BAD_REQUEST). It would be better to show the requested scopes to the end-user on the authentication device or somewhere appropriate. If the scope request parameter contains address, email, phone and/or profile, they are interpreted as defined in “5.4. Requesting Claims using Scope Values of OpenID Connect Core 1.0”. That is, they are expanded into a list of claim names. The claimNames parameter returns the expanded result.
binding_message A backchannel authentication request may contain a binding message. It is a human readable identifier or message intended to be displayed on both the consumption device (client application) and the authentication device.
user_code A backchannel authentication request may contain a user code. It is a secret code, such as password or pin, known only to the end-user but verifiable by the authorization server. The user code should be used to authorize sending a request to the authentication device.
[5] END-USER AUTHENTICATION AND AUTHORIZATION COMPLETIONAfter receiving the result of end-user authentication and authorization, the authorization server implementation must call Authlete’s /backchannel/authentication/complete API to tell Authlete the result and pass necessary data so that Authlete can generate an ID token, an access token and optionally a refresh token. See the description of the API for details.[6] CLIENT NOTIFICATIONWhen the backchannel token delivery mode is either ping or push, the authorization server implementation must send a notification to the pre-registered notification endpoint of the client after the end-user authentication and authorization. In this case, the action parameter in a response from /backchannel/authentication/complete API is NOTIFICATION. See the description of /backchannel/authentication/complete API for details.[7] TOKEN REQUESTWhen the backchannel token delivery mode is either ping or poll, the client application will make a token request to the token endpoint to get an ID token, an access token and optionally a refresh token. A token request that corresponds to a backchannel authentication request uses urn:openid:params:grant-type:ciba as the value of the grant_type request parameter. Authlete’s /auth/token API recognizes the grant type automatically and behaves properly, so the existing token endpoint implementation does not have to be changed to support CIBA.
Authenticate every request with a Service Access Token or Organization Token. Set the token value in the Authorization: Bearer <token> header.
Service Access Token: Scoped to a single service. Use when automating service-level configuration or runtime flows.
Organization Token: Scoped to the organization; inherits permissions across services. Use for org-wide automation or when managing multiple services programmatically.
Both token types are issued by the Authlete console or provisioning APIs.
Parameters of a backchannel authentication request which are the request parameters that the backchannel authentication endpoint of the OpenID provider implementation received from the client application.
The value of parameters is the entire entity body (which is formatted in application/x-www-form-urlencoded) of the request from the client application.
The client ID extracted from Authorization header of the backchannel authentication request from the client application.
If the backchannel authentication endpoint of the OpenID provider implementation supports Basic Authentication as a means of client authentication, and the request from the client application contained its client ID in Authorization header, the value should be extracted and set to this parameter.
The client secret extracted from Authorization header of the backchannel authentication request from the client application.
If the backchannel authentication endpoint of the OpenID provider implementation supports Basic Authentication as a means of client authentication, and the request from the client application contained its client secret in Authorization header, the value should be extracted and set to this parameter.
The content that the authorization server implementation is to return to the client application. Its format varies depending on the value of action parameter.
true if the value of the client_id request parameter included in the backchannel authentication request is the client ID alias. false if the value is the original numeric client ID.
The names of the claims which were requested indirectly via some special scopes. See 5.4. Requesting Claims using Scope Values in OpenID Connect Core 1.0 for details.
The list of ACR values requested by the backchannel authentication request.
Basically, this property holds the value of the acr_values request parameter in the backchannel authentication request. However, because unsupported ACR values are dropped on Authlete side, if the acr_values request parameter contains unrecognized ACR values, the list returned by this property becomes different from the value of the acr_values request parameter.
The flag which indicates whether a user code is required.
true when both the backchannel_user_code_parameter metadata of the client (= Client's bcUserCodeRequired property) and the backchannel_user_code_parameter_supported metadata of the service (= Service's backchannelUserCodeParameterSupported property) are true.
The request context of the backchannel authentication request.
It is the value of the request_context claim in the signed authentication request and its format is JSON. request_context is a new claim added by the FAPI-CIBA profile.
The resources specified by the resource request parameters or by the resource property in the request object. If both are given, the values in the request object should be set. See "Resource Indicators for OAuth 2.0" for details.
The authorization details. This represents the value of the authorization_details request parameter in the preceding device authorization request which is defined in "OAuth 2.0 Rich Authorization Requests".
The subject identifying the user who has given the grant identified by the grant_id request parameter of the device authorization request. Authlete 2.3 and newer versions support Grant Management for OAuth 2.0. An authorization request may contain a grant_id request parameter which is defined in the specification. If the value of the request parameter is valid, {@link #getGrantSubject()} will return the subject of the user who has given the grant to the client application. Authorization server implementations may use the value returned from {@link #getGrantSubject()} in order to determine the user to authenticate. The user your system will authenticate during the authorization process (or has already authenticated) may be different from the user of the grant. The first implementer's draft of "Grant Management for OAuth 2.0" does not mention anything about the case, so the behavior in the case is left to implementations. Authlete will not perform the grant management action when the subject passed to Authlete does not match the user of the grant.
Flag indicating whether a metadata document was used to resolve client metadata for this request.
When true, the client metadata was retrieved via the CIMD mechanism rather than from the Authlete database.
{"docsConfig":{"theme":"mint","$schema":"https://mintlify.com/docs.json","name":"Authlete Documentation","colors":{"primary":"#0057B7","light":"#4D8FEA","dark":"#0057B7"},"logo":{"light":"https://mintcdn.com/authlete/EJDZNZMvOu_9CJHJ/authlete-blue-horizontal-logo.svg?fit=max\u0026auto=format\u0026n=EJDZNZMvOu_9CJHJ\u0026q=85\u0026s=ed123a3de8b7791dffde03e7705c7460","dark":"https://mintcdn.com/authlete/EJDZNZMvOu_9CJHJ/authlete-blue-horizontal-logo.svg?fit=max\u0026auto=format\u0026n=EJDZNZMvOu_9CJHJ\u0026q=85\u0026s=ed123a3de8b7791dffde03e7705c7460"},"favicon":{"light":"https://mintcdn.com/authlete/gV1fxQkuH3uz_H3j/images/favicon-32x32.png?fit=max\u0026auto=format\u0026n=gV1fxQkuH3uz_H3j\u0026q=85\u0026s=9838a40b23e11ab35d7737e4c94a2d9a","dark":"https://mintcdn.com/authlete/gV1fxQkuH3uz_H3j/images/favicon-32x32.png?fit=max\u0026auto=format\u0026n=gV1fxQkuH3uz_H3j\u0026q=85\u0026s=9838a40b23e11ab35d7737e4c94a2d9a"},"api":{"openapi":"https://spec.speakeasy.com/authlete/sdk-workspace/authlete-api-explorer-with-code-samples","playground":{"display":"interactive","proxy":true},"examples":{"languages":["typescript","ruby","go","shell"],"autogenerate":true},"mdx":{"auth":{"method":"bearer"},"server":"https://us.authlete.com"}},"navbar":{"primary":{"type":"button","label":"Get Started","href":"https://console.authlete.com/"}},"footer":{"socials":{"x":"https://x.com/authlete","github":"https://github.com/authlete","linkedin":"https://linkedin.com/company/authlete"}},"contextual":{"options":["copy","view","chatgpt","claude","mcp","cursor"],"display":"header"},"thumbnails":{"fonts":{"family":"Noto Sans JP"}},"markdown":{"instructions":["### Authlete versions","Authlete 3.0 is the current version. Unless the user says they use another version, answer for Authlete 3.0 using the 3.x documentation.","Documentation for Authlete 2.x (pages under `/v2/` and `/ja/v2/`) is for the legacy version. Refer to it only when the user is on Authlete 2.x.","","### Authlete architecture","Authlete is a backend engine for OAuth 2.0 and OpenID Connect processing. End users and client applications do not call it directly; the service provider's authorization server and API server call Authlete's APIs. Authlete handles protocol processing and token, client, and service management, while the service provider owns the OAuth/OIDC endpoints and user authentication.","See [Architecture](https://developers.authlete.com/get-started/introduction-to-authlete/architecture.md).","","### Concepts","If the user is new to Authlete, read these pages first:","- [Request and Response](https://developers.authlete.com/get-started/concepts/request-and-response.md): Core API requests pass the client's request parameters as-is, and responses return `resultCode`, `action`, and `responseContent`.","- [Action Handling](https://developers.authlete.com/get-started/concepts/action-handling.md): Branch on `action`, never on `resultCode`, and map each action to the HTTP response your server returns.","- [Two-Step API Calls](https://developers.authlete.com/get-started/concepts/two-step-api-calls.md): Actions such as `INTERACTION` are completed with a second call (`/auth/authorization/issue` or `/auth/authorization/fail`) linked by a `ticket`.","- [Management API Overview](https://developers.authlete.com/get-started/concepts/overview.md): The Management API configures services, manages clients, and operates issued tokens, separately from the protocol flows handled by the Core API.","- [API Authentication](https://developers.authlete.com/get-started/concepts/authentication.md): Authlete APIs use bearer tokens: a Service Access Token (one service) or an Organization Token (the whole organization)."]},"styling":{"latex":false},"navigation":{"languages":[{"language":"en","default":true,"href":"get-started/introduction-to-authlete"},{"language":"ja","href":"ja/get-started/introduction-to-authlete"}]}},"deployment":{"deploymentMetadataValue":{"subdomain":"authlete","hasAudioNarration":false,"actualSubdomain":"authlete","customDomains":["developers.authlete.com"],"gitSource":{"type":"github","owner":"authlete","repo":"developer-docs","deployBranch":"main","contentDirectory":"","isPrivate":true,"mountPath":"","label":""},"chroma":{"liveDeploymentHistoryId":"6ad86bfbbcc1b0bac5b9a633","collectionId":"102eb795-336b-4b91-aae6-f3939575b917","schemaVersion":"v3","latestBuiltDeploymentHistoryId":"6ad86bfbbcc1b0bac5b9a633"},"feedback":{"thumbs":true,"agentFeedback":true},"entitlements":{"AI_CHAT":{"status":"DISABLED"}},"buildId":"6ad86bfbbcc1b0bac5b9a633","clientVersion":"0.0.3965","searchFilterCounts":[{"language":"en","tag":"Release Notes","count":103},{"language":"ja","tag":"リリースノート","count":103},{"language":"ja","tag":"設定リファレンス","count":92},{"language":"default","tag":"API Reference","count":87},{"language":"default","tag":"Authlete","count":87},{"language":"en","tag":"Configuration Reference","count":83},{"language":"en","tag":"Protocols \u0026 Flows","count":46},{"language":"en","tag":"Deployment \u0026 Operations","count":44},{"language":"ja","tag":"プロトコル \u0026 フロー","count":42},{"language":"ja","tag":"デプロイと運用","count":39},{"language":"ja","tag":"トークン \u0026 クレーム","count":38},{"language":"ja","tag":"はじめに","count":34},{"language":"ja","tag":"エンドポイント","count":33},{"language":"en","tag":"Get Started","count":32},{"language":"en","tag":"Tokens and Claims","count":28},{"language":"default","tag":"Client Management","count":26},{"language":"en","tag":"Endpoints","count":25},{"language":"en","tag":"Server Releases (v2.2)","count":23},{"language":"en","tag":"Server Releases (v2.3)","count":23},{"language":"ja","tag":"サーバーリリース (v2.2)","count":23},{"language":"ja","tag":"サーバーリリース (v2.3)","count":23},{"language":"en","tag":"Server Releases (v3.0)","count":20},{"language":"ja","tag":"サーバーリリース (v3.0)","count":20},{"language":"default","tag":"Verifiable Credential Issuer","count":11},{"language":"default","tag":"Service Management","count":6},{"language":"default","tag":"Authorization Endpoint","count":5},{"language":"default","tag":"Token Operations","count":5},{"language":"default","tag":"CIBA","count":4},{"language":"default","tag":"Dynamic Client Registration","count":4},{"language":"default","tag":"Hardware Security Key","count":4}],"searchSettings":{"maxResults":7}},"assistantConfig":{},"hasChatPermissions":false,"hasWebMcpPermissions":false,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-v7-file-tree","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"pause-universal-search-reconcile","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"per-site-search-delta","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-private-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-nav-generations","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"byok-sep-25","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"vite-origin","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-agent-model-picker","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-updated-9-15","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"privacy":{"consentBanner":{"enabled":true}},"isAtlas":false,"googleFontsInlined":false},"customCss":[{"filePath":"style.css","content":"#content-area,#navbar,#sidebar,[data-sidebar],body{background-image:none!important}.dynamic-curl-wrapper{width:100%;max-width:100%;min-width:0}.dynamic-curl-output{width:100%!important;max-width:100%!important;min-width:0!important}table[style*=tableLayout] td:last-child{overflow:hidden;min-width:0}table[style*=tableLayout] input{min-width:0}"}],"page":{"pagePath":"api-reference/ciba/process-backchannel-authentication-request","slug":"/api-reference/ciba/process-backchannel-authentication-request","pageMetadata":{"title":"Process Backchannel Authentication Request","description":"This API parses request parameters of a [backchannel authentication request](https://openid.net/specs/openid-client-initiated-backchannel-authentication-core-1_0.html#auth_request) and returns necessary data for the authorization server implementation to process the backchannel authentication request further.","deprecated":null,"version":null,"openapi":"https://spec.speakeasy.com/authlete/sdk-workspace/authlete-api-explorer-with-code-samples post /api/{serviceId}/backchannel/authentication","href":"/api-reference/ciba/process-backchannel-authentication-request","autogeneratedByOpenApi":true},"description":{"compiledSource":"\"use strict\";\nconst {jsx: _jsx, jsxs: _jsxs} = arguments[0];\nconst {useMDXComponents: _provideComponents} = arguments[0];\nfunction _createMdxContent(props) {\n const _components = {\n a: \"a\",\n p: \"p\",\n ..._provideComponents(),\n ...props.components\n };\n return _jsxs(_components.p, {\n children: [\"This API parses request parameters of a \", _jsx(_components.a, {\n href: \"https://openid.net/specs/openid-client-initiated-backchannel-authentication-core-1_0.html#auth_request\",\n children: \"backchannel authentication request\"\n }), \" and returns necessary data for the authorization server implementation to process the backchannel authentication request further.\"]\n });\n}\nfunction MDXContent(props = {}) {\n const {wrapper: MDXLayout} = {\n ..._provideComponents(),\n ...props.components\n };\n return MDXLayout ? _jsx(MDXLayout, {\n ...props,\n children: _jsx(_createMdxContent, {\n ...props\n })\n }) : _createMdxContent(props);\n}\nreturn {\n default: MDXContent\n};\n","frontmatter":{},"scope":{}},"pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{jsx:_jsx,jsxs:_jsxs}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){const _components={a:`a`,code:`code`,hr:`hr`,li:`li`,p:`p`,pre:`pre`,span:`span`,strong:`strong`,ul:`ul`,..._provideComponents(),...props.components},{Accordion,CodeBlock,Heading}=_components;if(!Accordion)_missingMdxReference(`Accordion`,true);if(!CodeBlock)_missingMdxReference(`CodeBlock`,true);if(!Heading)_missingMdxReference(`Heading`,true);return _jsxs(Accordion,{title:`Full description`,defaultOpen:false,id:`full-description`,children:[_jsxs(_components.p,{children:[`This API is supposed to be called from within the implementation of the `,_jsx(_components.a,{href:`https://openid.net/specs/openid-client-initiated-backchannel-authentication-core-1_0.html#auth_backchannel_endpoint`,children:`backchannel authentication endpoint`}),` of the service. The endpoint implementation must extract the request parameters from the backchannel authentication request from the client application and pass them as the value of parameters request parameter for Authlete’s `,_jsx(_components.code,{children:`/backchannel/authentication`}),` API. The value of parameters is the entire entity body (which is formatted in `,_jsx(_components.code,{children:`application/x-www-form-urlencoded`}),`) of the request from the client application. The following code snippet is an example in JAX-RS showing how to extract request parameters from the backchannel authentication request.`]}),_jsx(CodeBlock,{numberOfLines:`7`,language:`java`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`java`,children:_jsxs(_components.code,{language:`java`,numberOfLines:`7`,children:[_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`@`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#4EC9B0`},children:`POST`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`@`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#4EC9B0`},children:`Consumes`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`(`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#9CDCFE`},children:`MediaType`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`.`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#9CDCFE`},children:`APPLICATION_FORM_URLENCODED`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`)`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#569CD6`},children:`public`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#4EC9B0`},children:` Response`}),_jsx(_components.span,{style:{color:`#8250DF`,\"--shiki-dark\":`#DCDCAA`},children:` post`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`(`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#4EC9B0`},children:`String`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` parameters)`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D4D4D4`},children:`\u0026`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`#`}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#B5CEA8`},children:`123`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`;`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#6E7781`,\"--shiki-dark\":`#6A9955`},children:`// 'parameters' is the entity body of the backchannel authentication request.`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`......`})}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D4D4D4`},children:`\u0026`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`#`}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#B5CEA8`},children:`125`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`;`})]}),`\n`]})})}),_jsxs(_components.p,{children:[`The endpoint implementation does not have to parse the request parameters from the client application because Authlete’s `,_jsx(_components.code,{children:`/backchannel/authentication`}),` API does it. The response from `,_jsx(_components.code,{children:`/backchannel/authentication`}),` API has various parameters. Among them, it is `,_jsx(_components.code,{children:`action`}),` parameter that the authorization server implementation should check first because it denotes the next action that the authorization server implementation should take. According to the value of `,_jsx(_components.code,{children:`action`}),`, the service implementation must take the steps described below.`]}),_jsx(Heading,{level:`2`,id:`internal_server_error`,children:`INTERNAL_SERVER_ERROR`}),_jsxs(_components.p,{children:[`When the value of `,_jsx(_components.code,{children:`action`}),` is `,_jsx(_components.code,{children:`INTERNAL_SERVER_ERROR`}),`, it means that the request from the authorization server implementation was wrong or that an error occurred in Authlete. In either case, from the viewpoint of the client application, it is an error on the server side. Therefore, the service implementation should generate a response to the client application with HTTP status of “500 Internal Server Error” and `,_jsx(_components.code,{children:`application/json`}),`. The value of `,_jsx(_components.code,{children:`responseContent`}),` is a JSON string which describes the error, so it can be used as the entity body of the response.`]}),_jsx(_components.hr,{}),_jsx(_components.p,{children:`The following illustrates the response which the service implementation should generate and return to the client application.`}),_jsx(CodeBlock,{numberOfLines:`6`,language:`text`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`text`,children:_jsxs(_components.code,{language:`text`,numberOfLines:`6`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`HTTP/1.1 500 Internal Server Error`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Content-Type: application/json`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Cache-Control: no-store`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Pragma: no-cache`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#123;responseContent\u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{})})]})})}),_jsx(Heading,{level:`2`,id:`bad_request`,children:`BAD_REQUEST`}),_jsxs(_components.p,{children:[`When the value of `,_jsx(_components.code,{children:`action`}),` is `,_jsx(_components.code,{children:`BAD_REQUEST`}),`, it means that the request from the client application is invalid. The authorization server implementation should generate a response to the client application with “400 Bad Request” and `,_jsx(_components.code,{children:`application/json`}),`. The value of `,_jsx(_components.code,{children:`responseContent`}),` is a JSON string which describes the error, so it can be used as the entity body of the response.`]}),_jsx(_components.hr,{}),_jsx(_components.p,{children:`The following illustrates the response which the service implementation should generate and return to the client application.`}),_jsx(CodeBlock,{numberOfLines:`6`,language:`text`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`text`,children:_jsxs(_components.code,{language:`text`,numberOfLines:`6`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`HTTP/1.1 400 Bad Request`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Content-Type: application/json`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Cache-Control: no-store`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Pragma: no-cache`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#123;responseContent\u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{})})]})})}),_jsx(Heading,{level:`2`,id:`unauthorized`,children:`UNAUTHORIZED`}),_jsxs(_components.p,{children:[`When the value of `,_jsx(_components.code,{children:`action`}),` is `,_jsx(_components.code,{children:`UNAUTHORIZED`}),`, it means that client authentication of the backchannel authentication request failed. Note that client authentication is always required at the backchannel authentication endpoint. This implies that public clients are not allowed to use the backchannel authentication endpoint. The authorization server implementation should generate a response to the client application with “401 Unauthorized” and `,_jsx(_components.code,{children:`application/json`}),`. The value of `,_jsx(_components.code,{children:`responseContent`}),` is a JSON string which describes the error, so it can be used as the entity body of the response.`]}),_jsx(_components.hr,{}),_jsx(_components.p,{children:`The following illustrates the response which the service implementation must generate and return to the client application.`}),_jsx(CodeBlock,{numberOfLines:`7`,language:`text`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`text`,children:_jsxs(_components.code,{language:`text`,numberOfLines:`7`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`HTTP/1.1 401 Unauthorized`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`WWW-Authenticate: (challenge)`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Content-Type: application/json`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Cache-Control: no-store`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Pragma: no-cache`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#123;responseContent\u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{})})]})})}),_jsx(Heading,{level:`2`,id:`user_identification`,children:`USER_IDENTIFICATION`}),_jsxs(_components.p,{children:[`When the value of `,_jsx(_components.code,{children:`action`}),` is `,_jsx(_components.code,{children:`USER_IDENTIFICATION`}),`, it means that the backchannel authentication request from the client application is valid. The authorization server implementation has to follow the steps below.`]}),_jsx(_components.p,{children:_jsx(_components.strong,{children:`[1] END-USER IDENTIFICATION`})}),_jsxs(_components.p,{children:[`The first step is to determine the subject (= unique identifier) of the end-user from whom the client application wants to get authorization. According to the CIBA specification, a backchannel authentication request contains one (and only one) of the `,_jsx(_components.code,{children:`login_hint_token`}),`, `,_jsx(_components.code,{children:`id_token_hint`}),` and `,_jsx(_components.code,{children:`login_hint`}),` request parameters as a hint by which the authorization server identifies the subject of an end-user. The authorization server implementation can know which hint is included in the backchannel authentication request by the `,_jsx(_components.code,{children:`hintType`}),` parameter. For example, when the value of the parameter `,_jsx(_components.code,{children:`LOGIN_HINT`}),`, it means that the backchannel authentication request contains the `,_jsx(_components.code,{children:`login_hint`}),` request parameter as a hint. The value of the `,_jsx(_components.code,{children:`hint`}),` parameter is the value of the hint. For example, when the value of the `,_jsx(_components.code,{children:`hintType`}),` parameter is `,_jsx(_components.code,{children:`LOGIN_HINT`}),`, The value of the `,_jsx(_components.code,{children:`hint`}),` parameter is the value of the `,_jsx(_components.code,{children:`login_hint`}),` request parameter. It is up to the authorization server implementation how to determine the subject of the end-user from the hint. Only when the `,_jsx(_components.code,{children:`id_token_hint`}),` request parameter is used, authorization server implementation can use the sub response parameter, which holds the value of the sub claim in the `,_jsx(_components.code,{children:`id_token_hint`}),` request parameter.`]}),_jsx(_components.p,{children:_jsx(_components.strong,{children:`[2] END-USER IDENTIFICATION ERROR`})}),_jsx(_components.p,{children:`There are some cases where the authorization server implementation encounters an error during the user identification process. In any error case, the service implementation has to return an HTTP response with the error response parameter to the client application. The following is an example of such error responses.`}),_jsx(CodeBlock,{numberOfLines:`6`,language:`text`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`text`,children:_jsxs(_components.code,{language:`text`,numberOfLines:`6`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`HTTP/1.1 400 Bad Request`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Content-Type: application/json`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Cache-Control: no-store`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`Pragma: no-cache`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{children:`\u0026#123; \"error\":\"unknown_user_id\" \u0026#125;`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{})})]})})}),_jsxs(_components.p,{children:[`Authlete provides `,_jsx(_components.code,{children:`/backchannel/authentication/fail`}),` API that builds the response body (JSON) of an error response. However, because it is easy to build an error response manually, you may choose not to call the API. One good thing in using the API is that the API call can trigger deletion of the ticket which has been issued from Authlete’s `,_jsx(_components.code,{children:`/backchannel/authentication`}),` API. If you don’t call `,_jsx(_components.code,{children:`/backchannel/authentication/fail`}),` API, the ticket will continue to exist in the database until it is cleaned up by the batch program after the ticket expires. Possible error cases that the authorization server implementation itself has to handle are as follows. Other error cases have already been covered by `,_jsx(_components.code,{children:`/backchannel/authentication`}),` API.`]}),_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`expired_login_hint_token`}),` The authorization server implementation detected that the hint presented by the `,_jsx(_components.code,{children:`login_hint_token`}),` request parameter has expired. Note that the format of `,_jsx(_components.code,{children:`login_hint_token`}),` is not described in the CIBA Core spec at all and so there is no consensus on how to detect expiration of `,_jsx(_components.code,{children:`login_hint_token`}),`. Interpretation of `,_jsx(_components.code,{children:`login_hint_token`}),` is left to each authorization server implementation.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`unknown_user_id`}),` The authorization server implementation could not determine the subject of the end-user by the presented hint.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`unauthorized_client`}),` The authorization server implementation has custom rules to reject backchannel authentication requests from some particular clients and found that the client which has made the backchannel authentication request is one of the particular clients. Note that `,_jsx(_components.code,{children:`/backchannel/authentication`}),` API does not return `,_jsx(_components.code,{children:`action=USER_IDENTIFICATION`}),` in cases where the client does not exist or client authentication has failed. Therefore, the authorization server implementation will never have to use the error code `,_jsx(_components.code,{children:`unauthorized_client`}),` unless the server has intentionally implemented custom rules to reject backchannel authentication requests based on clients.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`missing_user_code`}),` The authorization server implementation has custom rules to require that a backchannel authentication request include a user code for some particular users and found that the user identified by the hint is one of the particular users. Note that `,_jsx(_components.code,{children:`/backchannel/authentication`}),` API does not return `,_jsx(_components.code,{children:`action=USER_IDENTIFICATION`}),` when both the `,_jsx(_components.code,{children:`backchannel_user_code_parameter_supported`}),` metadata of the server and the `,_jsx(_components.code,{children:`backchannel_user_code_parameter`}),` metadata of the client are true and the backchannel authentication request does not include the user_code request parameter. In this case, `,_jsx(_components.code,{children:`/backchannel/authentication`}),` API returns action=BAD_REQUEST with JSON containing `,_jsx(_components.code,{children:`\"error\":\"missing_user_code\"`}),`. Therefore, the authorization server implementation will never have to use the error code `,_jsx(_components.code,{children:`missing_user_code`}),` unless the server has intentionally implemented custom rules to require a user code based on users even in the case where the `,_jsx(_components.code,{children:`backchannel_user_code_parameter`}),` metadata of the client which has made the backchannel authentication request is `,_jsx(_components.code,{children:`false`}),`.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`invalid_user_code`}),` The authorization server implementation detected that the presented user code is invalid. Note that the format of user_code is not described in the CIBA Core spec at all and so there is no consensus on how to judge whether a user code is valid or not. It is up to each authorization server implementation how to handle user codes.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`invalid_binding_message`}),` The authorization server implementation detected that the presented binding message is invalid. Note that the format of binding_message is not described in the CIBA Core spec at all and so there is no consensus on how to judge whether a binding message is valid or not. It is up to each authorization server implementation how to handle binding messages.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`invalid_target`}),` The authorization server implementation rejects the requested target resources. The error code invalid_target is from “Resource Indicators for OAuth 2.0”. The specification defines the resource request parameter. By using the parameter, client applications can request target resources that should be bound to the access token being issued. If the authorization server wants to reject the request, call `,_jsx(_components.code,{children:`/backchannel/authentication/fail`}),` API with `,_jsx(_components.code,{children:`INVALID_TARGET`}),`.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`access_denined`}),` The authorization server implementation has custom rules to reject backchannel authentication requests without asking the end-user and respond to the client as if the end-user had rejected the request in some particular cases and found that the backchannel authentication request is one of the particular cases. The authorization server implementation will never have to use the error code `,_jsx(_components.code,{children:`access_denied`}),` at this timing unless the server has intentionally implemented custom rules to reject backchannel authentication requests without asking the end-user and respond to the client as if the end-user had rejected the request.`]}),`\n`]}),_jsx(_components.p,{children:_jsx(_components.strong,{children:`[3] AUTH_REQ_ID ISSUE`})}),_jsxs(_components.p,{children:[`If the authorization server implementation has successfully determined the subject of the end-user, the next action is to return an HTTP response to the client application which contains `,_jsx(_components.code,{children:`auth_req_id`}),`. Authlete provides `,_jsx(_components.code,{children:`/backchannel/authentication/issue`}),` API which generates a JSON containing `,_jsx(_components.code,{children:`auth_req_id`}),`, so, your next action is (1) call the API, (2) receive the response from the API, (3) build a response to the client application using the content of the API response, and (4) return the response to the client application. See the description of `,_jsx(_components.code,{children:`/backchannel/authentication/issue`}),` API for details.`]}),_jsx(_components.p,{children:_jsx(_components.strong,{children:`[4] END-USER AUTHENTICATION AND AUTHORIZATION`})}),_jsxs(_components.p,{children:[`After sending a JSON containing `,_jsx(_components.code,{children:`auth_req_id`}),` back to the client application, the service implementation starts to communicate with an authentication device of the end-user. It is assumed that end-user authentication is performed on the authentication device and the end-user confirms the content of the backchannel authentication request and grants authorization to the client application if everything is okay. The authorization server implementation must be able to receive the result of the end-user authentication and authorization from the authentication device. How to communicate with an authentication device and achieve end-user authentication and authorization is up to each authorization server implementation, but the following request parameters of the backchannel authentication request should be taken into consideration in any implementation.`]}),_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`acr_values`}),` A backchannel authentication request may contain an array of ACRs (Authentication Context Class References) in preference order. If multiple authentication devices are registered for the end-user, the authorization server implementation should take the ACRs into consideration when selecting the best authentication device.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`scope`}),` A backchannel authentication request always contains a list of scopes. At least, `,_jsx(_components.code,{children:`openid`}),` is included in the list (otherwise `,_jsx(_components.code,{children:`/backchannel/authentication`}),` API returns `,_jsx(_components.code,{children:`action=BAD_REQUEST`}),`). It would be better to show the requested scopes to the end-user on the authentication device or somewhere appropriate. If the scope request parameter contains `,_jsx(_components.code,{children:`address`}),`, `,_jsx(_components.code,{children:`email`}),`, `,_jsx(_components.code,{children:`phone`}),` and/or `,_jsx(_components.code,{children:`profile`}),`, they are interpreted as defined in “5.4. Requesting Claims using Scope Values of OpenID Connect Core 1.0”. That is, they are expanded into a list of claim names. The claimNames parameter returns the expanded result.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`binding_message`}),` A backchannel authentication request may contain a binding message. It is a human readable identifier or message intended to be displayed on both the consumption device (client application) and the authentication device.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`user_code`}),` A backchannel authentication request may contain a user code. It is a secret code, such as password or pin, known only to the end-user but verifiable by the authorization server. The user code should be used to authorize sending a request to the authentication device.`]}),`\n`]}),_jsx(_components.p,{children:_jsx(_components.strong,{children:`[5] END-USER AUTHENTICATION AND AUTHORIZATION COMPLETION`})}),_jsxs(_components.p,{children:[`After receiving the result of end-user authentication and authorization, the authorization server implementation must call Authlete’s `,_jsx(_components.code,{children:`/backchannel/authentication/complete`}),` API to tell Authlete the result and pass necessary data so that Authlete can generate an ID token, an access token and optionally a refresh token. See the description of the API for details.`]}),_jsx(_components.p,{children:_jsx(_components.strong,{children:`[6] CLIENT NOTIFICATION`})}),_jsxs(_components.p,{children:[`When the backchannel token delivery mode is either `,_jsx(_components.code,{children:`ping`}),` or `,_jsx(_components.code,{children:`push`}),`, the authorization server implementation must send a notification to the pre-registered notification endpoint of the client after the end-user authentication and authorization. In this case, the `,_jsx(_components.code,{children:`action`}),` parameter in a response from `,_jsx(_components.code,{children:`/backchannel/authentication/complete`}),` API is `,_jsx(_components.code,{children:`NOTIFICATION`}),`. See the description of `,_jsx(_components.code,{children:`/backchannel/authentication/complete`}),` API for details.`]}),_jsx(_components.p,{children:_jsx(_components.strong,{children:`[7] TOKEN REQUEST`})}),_jsxs(_components.p,{children:[`When the backchannel token delivery mode is either `,_jsx(_components.code,{children:`ping`}),` or `,_jsx(_components.code,{children:`poll`}),`, the client application will make a token request to the token endpoint to get an ID token, an access token and optionally a refresh token. A token request that corresponds to a backchannel authentication request uses `,_jsx(_components.code,{children:`urn:openid:params:grant-type:ciba`}),` as the value of the `,_jsx(_components.code,{children:`grant_type`}),` request parameter. Authlete’s `,_jsx(_components.code,{children:`/auth/token`}),` API recognizes the grant type automatically and behaves properly, so the existing token endpoint implementation does not have to be changed to support CIBA.`]})]})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent};function _missingMdxReference(id,component){throw new Error(`Expected `+(component?`component`:`object`)+\" `\"+id+\"` to be defined: you likely forgot to import, pass, or provide it.\")}","frontmatter":{},"scope":{"config":{},"pageMetadata":{"title":"Process Backchannel Authentication Request","description":"This API parses request parameters of a [backchannel authentication request](https://openid.net/specs/openid-client-initiated-backchannel-authentication-core-1_0.html#auth_request) and returns necessary data for the authorization server implementation to process the backchannel authentication request further.","deprecated":null,"version":null,"openapi":"https://spec.speakeasy.com/authlete/sdk-workspace/authlete-api-explorer-with-code-samples post /api/{serviceId}/backchannel/authentication","href":"/api-reference/ciba/process-backchannel-authentication-request","autogeneratedByOpenApi":true}}},"mdxSourceWithNoJs":null},"mdxExtracts":{"tableOfContents":[],"codeExamples":{}},"jsLinks":["/_mintlify/custom/authlete/a07b398e9c8556ba/snippets/oauth-dynamic.js"],"openApiReferenceData":{"operation":{"summary":"Process Backchannel Authentication Request","description":"This API parses request parameters of a [backchannel authentication request](https://openid.net/specs/openid-client-initiated-backchannel-authentication-core-1_0.html#auth_request) and returns necessary data for the authorization server implementation to process the backchannel authentication request further.","x-mint":{"metadata":{"description":"This API parses request parameters of a [backchannel authentication request](https://openid.net/specs/openid-client-initiated-backchannel-authentication-core-1_0.html#auth_request) and returns necessary data for the authorization server implementation to process the backchannel authentication request further."},"content":"\u003cAccordion title=\"Full description\" defaultOpen={false}>\nThis API is supposed to be called from within the implementation of the [backchannel authentication endpoint](https://openid.net/specs/openid-client-initiated-backchannel-authentication-core-1_0.html#auth_backchannel_endpoint) of the service. The endpoint implementation must extract the request parameters from the backchannel authentication request from the client application and pass them as the value of parameters request parameter for Authlete's `/backchannel/authentication` API. The value of parameters is the entire entity body (which is formatted in `application/x-www-form-urlencoded`) of the request from the client application. The following code snippet is an example in JAX-RS showing how to extract request parameters from the backchannel authentication request.\n```java\n@POST\n@Consumes(MediaType.APPLICATION_FORM_URLENCODED)\npublic Response post(String parameters)\n\u0026#123;\n// 'parameters' is the entity body of the backchannel authentication request.\n......\n\u0026#125;\n```\nThe endpoint implementation does not have to parse the request parameters from the client application because Authlete's `/backchannel/authentication` API does it. The response from `/backchannel/authentication` API has various parameters. Among them, it is `action` parameter that the authorization server implementation should check first because it denotes the next action that the authorization server implementation should take. According to the value of `action`, the service implementation must take the steps described below.\n\n## INTERNAL_SERVER_ERROR\n\nWhen the value of `action` is `INTERNAL_SERVER_ERROR`, it means that the request from the authorization server implementation was wrong or that an error occurred in Authlete. In either case, from the viewpoint of the client application, it is an error on the server side. Therefore, the service implementation should generate a response to the client application with HTTP status of \"500 Internal Server Error\" and `application/json`. The value of `responseContent` is a JSON string which describes the error, so it can be used as the entity body of the response.\n\n---\n\nThe following illustrates the response which the service implementation should generate and return to the client application.\n```\nHTTP/1.1 500 Internal Server Error\nContent-Type: application/json\nCache-Control: no-store\nPragma: no-cache\n\u0026#123;responseContent\u0026#125;\n```\n\n## BAD_REQUEST\n\nWhen the value of `action` is `BAD_REQUEST`, it means that the request from the client application is invalid. The authorization server implementation should generate a response to the client application with \"400 Bad Request\" and `application/json`. The value of `responseContent` is a JSON string which describes the error, so it can be used as the entity body of the response.\n\n---\n\nThe following illustrates the response which the service implementation should generate and return to the client application.\n```\nHTTP/1.1 400 Bad Request\nContent-Type: application/json\nCache-Control: no-store\nPragma: no-cache\n\u0026#123;responseContent\u0026#125;\n```\n\n## UNAUTHORIZED\n\nWhen the value of `action` is `UNAUTHORIZED`, it means that client authentication of the backchannel authentication request failed. Note that client authentication is always required at the backchannel authentication endpoint. This implies that public clients are not allowed to use the backchannel authentication endpoint. The authorization server implementation should generate a response to the client application with \"401 Unauthorized\" and `application/json`. The value of `responseContent` is a JSON string which describes the error, so it can be used as the entity body of the response.\n\n---\n\nThe following illustrates the response which the service implementation must generate and return to the client application.\n```\nHTTP/1.1 401 Unauthorized\nWWW-Authenticate: (challenge)\nContent-Type: application/json\nCache-Control: no-store\nPragma: no-cache\n\u0026#123;responseContent\u0026#125;\n```\n\n## USER_IDENTIFICATION\n\nWhen the value of `action` is `USER_IDENTIFICATION`, it means that the backchannel authentication request from the client application is valid. The authorization server implementation has to follow the steps below.\n\n**[1] END-USER IDENTIFICATION**\n\nThe first step is to determine the subject (= unique identifier) of the end-user from whom the client application wants to get authorization. According to the CIBA specification, a backchannel authentication request contains one (and only one) of the `login_hint_token`, `id_token_hint` and `login_hint` request parameters as a hint by which the authorization server identifies the subject of an end-user. The authorization server implementation can know which hint is included in the backchannel authentication request by the `hintType` parameter. For example, when the value of the parameter `LOGIN_HINT`, it means that the backchannel authentication request contains the `login_hint` request parameter as a hint. The value of the `hint` parameter is the value of the hint. For example, when the value of the `hintType` parameter is `LOGIN_HINT`, The value of the `hint` parameter is the value of the `login_hint` request parameter. It is up to the authorization server implementation how to determine the subject of the end-user from the hint. Only when the `id_token_hint` request parameter is used, authorization server implementation can use the sub response parameter, which holds the value of the sub claim in the `id_token_hint` request parameter.\n\n**[2] END-USER IDENTIFICATION ERROR**\n\nThere are some cases where the authorization server implementation encounters an error during the user identification process. In any error case, the service implementation has to return an HTTP response with the error response parameter to the client application. The following is an example of such error responses.\n ```\n HTTP/1.1 400 Bad Request\n Content-Type: application/json\n Cache-Control: no-store\n Pragma: no-cache\n \u0026#123; \"error\":\"unknown_user_id\" \u0026#125;\n ```\n Authlete provides `/backchannel/authentication/fail` API that builds the response body (JSON) of an error response. However, because it is easy to build an error response manually, you may choose not to call the API. One good thing in using the API is that the API call can trigger deletion of the ticket which has been issued from Authlete's `/backchannel/authentication` API. If you don't call `/backchannel/authentication/fail` API, the ticket will continue to exist in the database until it is cleaned up by the batch program after the ticket expires. Possible error cases that the authorization server implementation itself has to handle are as follows. Other error cases have already been covered by `/backchannel/authentication` API.\n- `expired_login_hint_token` The authorization server implementation detected that the hint presented by the `login_hint_token` request parameter has expired. Note that the format of `login_hint_token` is not described in the CIBA Core spec at all and so there is no consensus on how to detect expiration of `login_hint_token`. Interpretation of `login_hint_token` is left to each authorization server implementation.\n- `unknown_user_id` The authorization server implementation could not determine the subject of the end-user by the presented hint.\n- `unauthorized_client` The authorization server implementation has custom rules to reject backchannel authentication requests from some particular clients and found that the client which has made the backchannel authentication request is one of the particular clients. Note that `/backchannel/authentication` API does not return `action=USER_IDENTIFICATION` in cases where the client does not exist or client authentication has failed. Therefore, the authorization server implementation will never have to use the error code `unauthorized_client` unless the server has intentionally implemented custom rules to reject backchannel authentication requests based on clients.\n- `missing_user_code` The authorization server implementation has custom rules to require that a backchannel authentication request include a user code for some particular users and found that the user identified by the hint is one of the particular users. Note that `/backchannel/authentication` API does not return `action=USER_IDENTIFICATION` when both the `backchannel_user_code_parameter_supported` metadata of the server and the `backchannel_user_code_parameter` metadata of the client are true and the backchannel authentication request does not include the user_code request parameter. In this case, `/backchannel/authentication` API returns action=BAD_REQUEST with JSON containing `\"error\":\"missing_user_code\"`. Therefore, the authorization server implementation will never have to use the error code `missing_user_code` unless the server has intentionally implemented custom rules to require a user code based on users even in the case where the `backchannel_user_code_parameter` metadata of the client which has made the backchannel authentication request is `false`.\n- `invalid_user_code` The authorization server implementation detected that the presented user code is invalid. Note that the format of user_code is not described in the CIBA Core spec at all and so there is no consensus on how to judge whether a user code is valid or not. It is up to each authorization server implementation how to handle user codes.\n- `invalid_binding_message` The authorization server implementation detected that the presented binding message is invalid. Note that the format of binding_message is not described in the CIBA Core spec at all and so there is no consensus on how to judge whether a binding message is valid or not. It is up to each authorization server implementation how to handle binding messages.\n- `invalid_target` The authorization server implementation rejects the requested target resources. The error code invalid_target is from \"Resource Indicators for OAuth 2.0\". The specification defines the resource request parameter. By using the parameter, client applications can request target resources that should be bound to the access token being issued. If the authorization server wants to reject the request, call `/backchannel/authentication/fail` API with `INVALID_TARGET`.\n- `access_denined` The authorization server implementation has custom rules to reject backchannel authentication requests without asking the end-user and respond to the client as if the end-user had rejected the request in some particular cases and found that the backchannel authentication request is one of the particular cases. The authorization server implementation will never have to use the error code `access_denied` at this timing unless the server has intentionally implemented custom rules to reject backchannel authentication requests without asking the end-user and respond to the client as if the end-user had rejected the request.\n\n**[3] AUTH_REQ_ID ISSUE**\n\nIf the authorization server implementation has successfully determined the subject of the end-user, the next action is to return an HTTP response to the client application which contains `auth_req_id`. Authlete provides `/backchannel/authentication/issue` API which generates a JSON containing `auth_req_id`, so, your next action is (1) call the API, (2) receive the response from the API, (3) build a response to the client application using the content of the API response, and (4) return the response to the client application. See the description of `/backchannel/authentication/issue` API for details.\n\n**[4] END-USER AUTHENTICATION AND AUTHORIZATION**\n\nAfter sending a JSON containing `auth_req_id` back to the client application, the service implementation starts to communicate with an authentication device of the end-user. It is assumed that end-user authentication is performed on the authentication device and the end-user confirms the content of the backchannel authentication request and grants authorization to the client application if everything is okay. The authorization server implementation must be able to receive the result of the end-user authentication and authorization from the authentication device. How to communicate with an authentication device and achieve end-user authentication and authorization is up to each authorization server implementation, but the following request parameters of the backchannel authentication request should be taken into consideration in any implementation.\n- `acr_values` A backchannel authentication request may contain an array of ACRs (Authentication Context Class References) in preference order. If multiple authentication devices are registered for the end-user, the authorization server implementation should take the ACRs into consideration when selecting the best authentication device.\n- `scope` A backchannel authentication request always contains a list of scopes. At least, `openid` is included in the list (otherwise `/backchannel/authentication` API returns `action=BAD_REQUEST`). It would be better to show the requested scopes to the end-user on the authentication device or somewhere appropriate. If the scope request parameter contains `address`, `email`, `phone` and/or `profile`, they are interpreted as defined in \"5.4. Requesting Claims using Scope Values of OpenID Connect Core 1.0\". That is, they are expanded into a list of claim names. The claimNames parameter returns the expanded result.\n- `binding_message` A backchannel authentication request may contain a binding message. It is a human readable identifier or message intended to be displayed on both the consumption device (client application) and the authentication device.\n- `user_code` A backchannel authentication request may contain a user code. It is a secret code, such as password or pin, known only to the end-user but verifiable by the authorization server. The user code should be used to authorize sending a request to the authentication device.\n\n**[5] END-USER AUTHENTICATION AND AUTHORIZATION COMPLETION**\n\nAfter receiving the result of end-user authentication and authorization, the authorization server implementation must call Authlete's `/backchannel/authentication/complete` API to tell Authlete the result and pass necessary data so that Authlete can generate an ID token, an access token and optionally a refresh token. See the description of the API for details.\n\n**[6] CLIENT NOTIFICATION**\n\nWhen the backchannel token delivery mode is either `ping` or `push`, the authorization server implementation must send a notification to the pre-registered notification endpoint of the client after the end-user authentication and authorization. In this case, the `action` parameter in a response from `/backchannel/authentication/complete` API is `NOTIFICATION`. See the description of `/backchannel/authentication/complete` API for details.\n\n**[7] TOKEN REQUEST**\n\nWhen the backchannel token delivery mode is either `ping` or `poll`, the client application will make a token request to the token endpoint to get an ID token, an access token and optionally a refresh token. A token request that corresponds to a backchannel authentication request uses `urn:openid:params:grant-type:ciba` as the value of the `grant_type` request parameter. Authlete's `/auth/token` API recognizes the grant type automatically and behaves properly, so the existing token endpoint implementation does not have to be changed to support CIBA.\n\u003c/Accordion>\n"},"parameters":["d04fa7c8-3e8d-480a-8993-2c4f6b8abbb9"],"requestBody":"43b1fd88-38bd-456f-b793-e81f5f862a61","responses":{"200":"8f7c9698-e691-4475-97cf-0c88000617bb","400":"ae51aa61-6caf-4f3a-890f-61b38349b912","401":"b142b7ab-cbe8-4c17-9de8-fddddcfa2cc7","403":"cd82096b-beca-4a26-88a0-002df108251d","429":"11e02627-6461-451f-9c9f-b94dae0b454b","500":"4d8080b3-78da-4cad-802c-1334f2604995"},"operationId":"backchannel_authentication_api","x-code-samples":[{"lang":"shell","label":"curl","source":"curl -v -X POST https://us.authlete.com/api/21653835348762/backchannel/authentication \\\n-H 'Content-Type: application/json' \\\n-H 'Authorization: Bearer V5a40R6dWvw2gMkCOBFdZcM95q4HC0Z-T0YKD9-nR6F' \\\n-d '{ \"parameters\": \"login_hint=john\u0026scope=openid\u0026client_notification_token=my-client-notification-token\u0026user_code=my-user-code\", \"clientId\": \"26862190133482\", \"clientSecret\":\"8J9pAEX6IQw7lYtYGsc_s9N4jlEz_DfkoCHIswJjFjfgKZX-nC4EvKtaHXcP9mHBfS7IU4jytjSZZpaK9UJ77A\" }'\n"},{"lang":"java","label":"java","source":"AuthleteConfiguration conf = ...;\nAuthleteApi api = AuthleteApiFactory.create(conf);\n\nBackchannelAuthenticationRequest req = new BackchannelAuthenticationRequest();\nreq.setParameters(...);\nreq.setClientId(\"26862190133482\");\nreq.setClientSecret(\"8J9pAEX6IQw7lYtYGsc_s9N4jlEz_DfkoCHIswJjFjfgKZX-nC4EvKtaHXcP9mHBfS7IU4jytjSZZpaK9UJ77A\");\n\napi.backchannelAuthentication(req);\n"},{"lang":"python","source":"conf = ...\napi = AuthleteApiImpl(conf)\n\nreq = BackchannelAuthenticationRequest()\nreq.parameters = ...\nreq.clientId = '26862190133482'\nreq.clientSecret = '8J9pAEX6IQw7lYtYGsc_s9N4jlEz_DfkoCHIswJjFjfgKZX-nC4EvKtaHXcP9mHBfS7IU4jytjSZZpaK9UJ77A'\n\napi.backchannelAuthentication(req)\n"}],"tags":["CIBA"],"x-speakeasy-group":"ciba","x-speakeasy-name-override":"processAuthentication","x-codeSamples":[{"lang":"typescript","label":"Typescript (SDK)","source":"import { Authlete } from \"@authlete/typescript-sdk\";\n\nconst authlete = new Authlete({\n serviceId: \"\u003cid>\",\n bearer: process.env[\"AUTHLETE_BEARER\"] ?? \"\",\n});\n\nasync function run() {\n const result = await authlete.ciba.processAuthentication({\n backchannelAuthenticationRequest: {\n parameters: \"login_hint=john\u0026scope=openid\u0026client_notification_token=my-client-notification-token\u0026user_code=my-user-code\",\n clientId: \"26862190133482\",\n clientSecret: \"8J9pAEX6IQw7lYtYGsc_s9N4jlEz_DfkoCHIswJjFjfgKZX-nC4EvKtaHXcP9mHBfS7IU4jytjSZZpaK9UJ77A\",\n },\n });\n\n console.log(result);\n}\n\nrun();"},{"lang":"ruby","label":"Ruby (SDK)","source":"require 'authlete_ruby_sdk'\n\nModels = ::Authlete::Models\ns = ::Authlete::Client.new(\n service_id: '\u003cid>',\n bearer: '\u003cYOUR_BEARER_TOKEN_HERE>'\n)\nres = s.ciba.process_authentication(backchannel_authentication_request: Models::Components::BackchannelAuthenticationRequest.new(\n parameters: 'login_hint=john\u0026scope=openid\u0026client_notification_token=my-client-notification-token\u0026user_code=my-user-code',\n client_id: '26862190133482',\n client_secret: '8J9pAEX6IQw7lYtYGsc_s9N4jlEz_DfkoCHIswJjFjfgKZX-nC4EvKtaHXcP9mHBfS7IU4jytjSZZpaK9UJ77A'\n))\n\nunless res.backchannel_authentication_response.nil?\n # handle response\nend"},{"lang":"go","label":"Go (SDK)","source":"package main\n\nimport(\n\t\"context\"\n\t\"os\"\n\tauthlete \"github.com/authlete/authlete-go-sdk\"\n\t\"github.com/authlete/authlete-go-sdk/models/components\"\n\t\"github.com/authlete/authlete-go-sdk/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n ctx := context.Background()\n\n s := authlete.New(\n authlete.WithServiceID(\"\u003cid>\"),\n authlete.WithSecurity(os.Getenv(\"AUTHLETE_BEARER\")),\n )\n\n res, err := s.Ciba.ProcessAuthentication(ctx, operations.BackchannelAuthenticationAPIRequest{\n Body: components.BackchannelAuthenticationRequest{\n Parameters: \"login_hint=john\u0026scope=openid\u0026client_notification_token=my-client-notification-token\u0026user_code=my-user-code\",\n ClientID: authlete.Pointer(\"26862190133482\"),\n ClientSecret: authlete.Pointer(\"8J9pAEX6IQw7lYtYGsc_s9N4jlEz_DfkoCHIswJjFjfgKZX-nC4EvKtaHXcP9mHBfS7IU4jytjSZZpaK9UJ77A\"),\n },\n })\n if err != nil {\n log.Fatal(err)\n }\n if res.BackchannelAuthenticationResponse != nil {\n // handle response\n }\n}"}],"method":"post","type":"path","servers":["86730d38-5978-49f4-83dc-79ee32a13d9f","6b1844ca-4ef4-4a3a-aa78-226ce86b6b87","428ca9ef-6a06-47df-8d21-45d932468e02","02c44588-9e42-4914-bdc7-134510ec7325"],"security":["462b635e-c1d5-42f6-b3a8-ef7d418285aa"],"path":"/api/{serviceId}/backchannel/authentication","baseUrlOptions":["https://us.authlete.com","https://jp.authlete.com","https://eu.authlete.com","https://br.authlete.com"],"title":"Process Backchannel Authentication Request","codeSamples":[{"label":"Typescript (SDK)","lang":"typescript","source":"import { Authlete } from \"@authlete/typescript-sdk\";\n\nconst authlete = new Authlete({\n serviceId: \"\u003cid>\",\n bearer: process.env[\"AUTHLETE_BEARER\"] ?? \"\",\n});\n\nasync function run() {\n const result = await authlete.ciba.processAuthentication({\n backchannelAuthenticationRequest: {\n parameters: \"login_hint=john\u0026scope=openid\u0026client_notification_token=my-client-notification-token\u0026user_code=my-user-code\",\n clientId: \"26862190133482\",\n clientSecret: \"8J9pAEX6IQw7lYtYGsc_s9N4jlEz_DfkoCHIswJjFjfgKZX-nC4EvKtaHXcP9mHBfS7IU4jytjSZZpaK9UJ77A\",\n },\n });\n\n console.log(result);\n}\n\nrun();"},{"label":"Ruby (SDK)","lang":"ruby","source":"require 'authlete_ruby_sdk'\n\nModels = ::Authlete::Models\ns = ::Authlete::Client.new(\n service_id: '\u003cid>',\n bearer: '\u003cYOUR_BEARER_TOKEN_HERE>'\n)\nres = s.ciba.process_authentication(backchannel_authentication_request: Models::Components::BackchannelAuthenticationRequest.new(\n parameters: 'login_hint=john\u0026scope=openid\u0026client_notification_token=my-client-notification-token\u0026user_code=my-user-code',\n client_id: '26862190133482',\n client_secret: '8J9pAEX6IQw7lYtYGsc_s9N4jlEz_DfkoCHIswJjFjfgKZX-nC4EvKtaHXcP9mHBfS7IU4jytjSZZpaK9UJ77A'\n))\n\nunless res.backchannel_authentication_response.nil?\n # handle response\nend"},{"label":"Go (SDK)","lang":"go","source":"package main\n\nimport(\n\t\"context\"\n\t\"os\"\n\tauthlete \"github.com/authlete/authlete-go-sdk\"\n\t\"github.com/authlete/authlete-go-sdk/models/components\"\n\t\"github.com/authlete/authlete-go-sdk/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n ctx := context.Background()\n\n s := authlete.New(\n authlete.WithServiceID(\"\u003cid>\"),\n authlete.WithSecurity(os.Getenv(\"AUTHLETE_BEARER\")),\n )\n\n res, err := s.Ciba.ProcessAuthentication(ctx, operations.BackchannelAuthenticationAPIRequest{\n Body: components.BackchannelAuthenticationRequest{\n Parameters: \"login_hint=john\u0026scope=openid\u0026client_notification_token=my-client-notification-token\u0026user_code=my-user-code\",\n ClientID: authlete.Pointer(\"26862190133482\"),\n ClientSecret: authlete.Pointer(\"8J9pAEX6IQw7lYtYGsc_s9N4jlEz_DfkoCHIswJjFjfgKZX-nC4EvKtaHXcP9mHBfS7IU4jytjSZZpaK9UJ77A\"),\n },\n })\n if err != nil {\n log.Fatal(err)\n }\n if res.BackchannelAuthenticationResponse != nil {\n // handle response\n }\n}"}],"requestExampleLanguages":["typescript","ruby","go","bash"],"requiredOnlyExamples":false,"requestExampleType":"codeSamples","responseExampleType":"generated"},"dependencies":{"parameters":{"d04fa7c8-3e8d-480a-8993-2c4f6b8abbb9":{"in":"path","name":"serviceId","description":"A service ID.","schema":{"type":"string","isRequired":true,"description":"A service ID.","uniqueKey":"","typeLabel":"string"},"required":true}},"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","required":["parameters"],"properties":{"parameters":{"type":"string","description":"Parameters of a backchannel authentication request which are the request parameters that the backchannel authentication endpoint of the OpenID provider implementation received from the client application.\n\nThe value of `parameters` is the entire entity body (which is formatted in `application/x-www-form-urlencoded`) of the request from the client application.\n","isRequired":true,"uniqueKey":"parameters","typeLabel":"string"},"clientId":{"type":"string","description":"The client ID extracted from Authorization header of the backchannel authentication request from the client application.\n\nIf the backchannel authentication endpoint of the OpenID provider implementation supports Basic Authentication as a means of client authentication, and the request from the client application contained its client ID in Authorization header, the value should be extracted and set to this parameter.\n","uniqueKey":"clientId","typeLabel":"string"},"clientSecret":{"type":"string","description":"The client secret extracted from Authorization header of the backchannel authentication request from the client application.\n\nIf the backchannel authentication endpoint of the OpenID provider implementation supports Basic Authentication as a means of client authentication, and the request from the client application contained its client secret in Authorization header, the value should be extracted and set to this parameter.\n","uniqueKey":"clientSecret","typeLabel":"string"},"clientCertificate":{"type":"string","description":"The client certification used in the TLS connection between the client application and the backchannel authentication endpoint of the OpenID provider.\n","uniqueKey":"clientCertificate","typeLabel":"string"},"clientCertificatePath":{"type":"array","items":{"type":"string","uniqueKey":"clientCertificatePath.items.[INDEX]","typeLabel":"string"},"description":"The client certificate path presented by the client during client authentication. Each element is a string in PEM format.\n","uniqueKey":"clientCertificatePath","typeLabel":"string[]"},"oauthClientAttestation":{"type":"string","description":"The value of the `OAuth-Client-Attestation` HTTP header, which is defined in the specification of [OAuth 2.0 Attestation-Based Client Authentication](https://datatracker.ietf.org/doc/draft-ietf-oauth-attestation-based-client-auth/).\n","uniqueKey":"oauthClientAttestation","typeLabel":"string"},"oauthClientAttestationPop":{"type":"string","description":"The value of the `OAuth-Client-Attestation-PoP` HTTP header, which is defined in the specification of [OAuth 2.0 Attestation-Based Client Authentication](https://datatracker.ietf.org/doc/draft-ietf-oauth-attestation-based-client-auth/).\n","uniqueKey":"oauthClientAttestationPop","typeLabel":"string"},"cimdOptions":{"type":"object","description":"Options for [OAuth Client ID Metadata Document](https://datatracker.ietf.org/doc/draft-ietf-oauth-client-id-metadata-document/) (CIMD).\n\nThese options allow per-request control over CIMD behavior, taking precedence over service-level configuration when provided.\n","properties":{"alwaysRetrieved":{"type":"boolean","description":"Whether to always retrieve client metadata in the CIMD context regardless of the cache's validity.\n\nUnder normal circumstances, client metadata retrieved from the location referenced by the client ID is stored in the database with an expiration time calculated using HTTP caching mechanisms (see [RFC 9111 HTTP Caching](https://www.rfc-editor.org/rfc/rfc9111.html)). Until that expiration time is reached, Authlete does not attempt to retrieve the client metadata again.\n\nWhen this flag is set to `true`, Authlete retrieves the client metadata regardless of the cache's validity.\n\nIf this flag is included in an Authlete API call and its value is `true`, it takes precedence over the corresponding service configuration (see `Service.cimdAlwaysRetrieved`).\n\nThis flag is effective only when the service supports CIMD (see `Service.clientIdMetadataDocumentSupported`) and CIMD is actually used to resolve client metadata. For example, if the client ID in a request does not appear to be a valid URI, CIMD will not be used even if the service is configured to support it. In such cases, this flag has no effect.\n\nClient metadata retrieval is performed only in the initiating request of an authorization flow, and not in any subsequent requests. For example, in the authorization code flow, metadata may be retrieved during the authorization request, but not during the subsequent token request. In contrast, in the client credentials flow, metadata retrieval may occur because the token request itself is the initiating request in the flow.\n","uniqueKey":"cimdOptions.alwaysRetrieved","typeLabel":"boolean"},"httpPermitted":{"type":"boolean","description":"Whether to allow the `http` scheme in client IDs in the CIMD context.\n\nThe specification requires the `https` scheme, but if this flag is set to `true`, Authlete also allows the `http` scheme. The main purpose of this option is to make development easier for developers who run CIMD-enabled servers and a web server publishing client metadata on their local machines without TLS.\n\nGiven this purpose, it is not recommended to enable this option in production environments unless an allowlist is used (see `Service.cimdAllowlistEnabled`).\n\nIf this flag is included in an Authlete API call and its value is `true`, it takes precedence over the corresponding service configuration (see `Service.cimdHttpPermitted`).\n","uniqueKey":"cimdOptions.httpPermitted","typeLabel":"boolean"},"queryPermitted":{"type":"boolean","description":"Whether to allow a query component in client IDs in the CIMD context.\n\nAlthough the specification states that a client ID \"SHOULD NOT include a query string component,\" it does technically allow it. However, query components are prone to misuse. Therefore, Authlete does not allow them by default. Setting this flag to `true` relaxes that restriction.\n\nIf this flag is included in an Authlete API call and its value is `true`, it takes precedence over the corresponding service configuration (see `Service.cimdQueryPermitted`).\n","uniqueKey":"cimdOptions.queryPermitted","typeLabel":"boolean"}},"uniqueKey":"cimdOptions","typeLabel":"object"}},"uniqueKey":"","typeLabel":"object"},"example":{"parameters":"login_hint=john\u0026scope=openid\u0026client_notification_token=my-client-notification-token\u0026user_code=my-user-code","clientId":"26862190133482","clientSecret":"8J9pAEX6IQw7lYtYGsc_s9N4jlEz_DfkoCHIswJjFjfgKZX-nC4EvKtaHXcP9mHBfS7IU4jytjSZZpaK9UJ77A"},"examples":{"Example":{"title":"Example","value":{"parameters":"login_hint=john\u0026scope=openid\u0026client_notification_token=my-client-notification-token\u0026user_code=my-user-code","clientId":"26862190133482","clientSecret":"8J9pAEX6IQw7lYtYGsc_s9N4jlEz_DfkoCHIswJjFjfgKZX-nC4EvKtaHXcP9mHBfS7IU4jytjSZZpaK9UJ77A"}}},"exampleType":"examples"},"application/x-www-form-urlencoded":{"schema":{"type":"object","required":["parameters"],"properties":{"parameters":{"type":"string","description":"Parameters of a backchannel authentication request which are the request parameters that the backchannel authentication endpoint of the OpenID provider implementation received from the client application.\n\nThe value of `parameters` is the entire entity body (which is formatted in `application/x-www-form-urlencoded`) of the request from the client application.\n","isRequired":true,"uniqueKey":"parameters","typeLabel":"string"},"clientId":{"type":"string","description":"The client ID extracted from Authorization header of the backchannel authentication request from the client application.\n\nIf the backchannel authentication endpoint of the OpenID provider implementation supports Basic Authentication as a means of client authentication, and the request from the client application contained its client ID in Authorization header, the value should be extracted and set to this parameter.\n","uniqueKey":"clientId","typeLabel":"string"},"clientSecret":{"type":"string","description":"The client secret extracted from Authorization header of the backchannel authentication request from the client application.\n\nIf the backchannel authentication endpoint of the OpenID provider implementation supports Basic Authentication as a means of client authentication, and the request from the client application contained its client secret in Authorization header, the value should be extracted and set to this parameter.\n","uniqueKey":"clientSecret","typeLabel":"string"},"clientCertificate":{"type":"string","description":"The client certification used in the TLS connection between the client application and the backchannel authentication endpoint of the OpenID provider.\n","uniqueKey":"clientCertificate","typeLabel":"string"},"clientCertificatePath":{"type":"array","items":{"type":"string","uniqueKey":"clientCertificatePath.items.[INDEX]","typeLabel":"string"},"description":"The client certificate path presented by the client during client authentication. Each element is a string in PEM format.\n","uniqueKey":"clientCertificatePath","typeLabel":"string[]"},"oauthClientAttestation":{"type":"string","description":"The value of the `OAuth-Client-Attestation` HTTP header, which is defined in the specification of [OAuth 2.0 Attestation-Based Client Authentication](https://datatracker.ietf.org/doc/draft-ietf-oauth-attestation-based-client-auth/).\n","uniqueKey":"oauthClientAttestation","typeLabel":"string"},"oauthClientAttestationPop":{"type":"string","description":"The value of the `OAuth-Client-Attestation-PoP` HTTP header, which is defined in the specification of [OAuth 2.0 Attestation-Based Client Authentication](https://datatracker.ietf.org/doc/draft-ietf-oauth-attestation-based-client-auth/).\n","uniqueKey":"oauthClientAttestationPop","typeLabel":"string"},"cimdOptions":{"type":"object","description":"Options for [OAuth Client ID Metadata Document](https://datatracker.ietf.org/doc/draft-ietf-oauth-client-id-metadata-document/) (CIMD).\n\nThese options allow per-request control over CIMD behavior, taking precedence over service-level configuration when provided.\n","properties":{"
[...]
